<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>JR3.30 - Load Students Json to Table</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- nhúng thư viện awsome font  -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
     <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  

</head>
<body>
    <div class="container">
        <h2 class="text-center">Danh sách sinh viên</h2>
        <button class="btn btn-success"><i class="fas fa-user-plus fa-lg">&nbsp;</i>Thêm sinh viên</button>
       <br><br>
        <!-- content  -->
        <div class="float-center">
            <table class="table table-bordered table-striped table-hover table-primary" id="table-student">
                <thead>
                  <tr>
                    <th>ID</th>
                    <th><Nav>NAME</Nav></th>
                    <th>BIRTHDAY</th>
                    <th>EMAIL</th>
                    <th>PHONE</th>
                    <th>ACTION</th>

                  </tr>
              </table>
        </div>
        <!-- content -->
    </div>
   
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATE_SUCCESS = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://devcamp-student-datatables.herokuapp.com/users/";
       //creata a data for DataTable
       const gCOLUMN_ID = 0;
        const gCOLUMN_HO_TEN = 1;
        const gCOLUMN_BIRTHDAY = 2;
        const gCOLUMN_EMAIL = 3;
        const gCOLUMN_PHONE = 4 ;
        const gCOLUMN_ACTION = 5;
        

        const gNAME_COL = ["id","name","birthday","email",
            "phone","Action"];
            
            // định nghĩa table  - chưa có data
         var gUserTable = $("#table-student").DataTable( {
            // Khai báo các cột của datatable
            "columns" : [
                { "data" : gNAME_COL[gCOLUMN_ID] },
                { "data" : gNAME_COL[gCOLUMN_HO_TEN] },
                { "data" : gNAME_COL[gCOLUMN_BIRTHDAY] },
                { "data" : gNAME_COL[gCOLUMN_EMAIL] },
                { "data" : gNAME_COL[gCOLUMN_PHONE] },
                { "data" : gNAME_COL[gCOLUMN_ACTION] }
            ],
            // Ghi đè nội dung của cột action, chuyển thành button chi tiết
            "columnDefs": [ 
            {
                "targets": gCOLUMN_ACTION,
                // "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
               // "defaultContent":  '<i class="fas fa-edit fa-lg edit-icon text-left" style="cursor:pointer; color:green;"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i class="fas fa-trash-alt fa-lg delete-icon  text-right"  style="cursor:pointer; color:red;"></i>'
               "defaultContent": "<button class='update-user btn btn-info'>update</button> &nbsp;&nbsp;<button class='delete-user btn btn-danger'>delete</button>  "
            }]
        });
        onPageLoading();
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  

    //function on click update
        $("#table-student").on("click",".update-user",function(){
            var vIfnfoStudent = getCurrentInfo(this);
           
           
        })
    //function on click update

     //function on click delete
        $("#table-student").on("click",".delete-user",function(){
            var vIfnfoStudent = getCurrentInfo(this);
           
            
        })
     //end function on click delete

         /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    //load table 
        function onPageLoading(){
            debugger;
            getAllUsers();
        }
        // Mẫu gọi API load all users
        function getAllUsers() {
        // create a request
        var vXmlHttObj = new XMLHttpRequest();
        vXmlHttObj.open("GET", gBASE_URL, true);
        vXmlHttObj.send();
        vXmlHttObj.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttObj.responseText);
                var vListStudent = JSON.parse(vXmlHttObj.responseText);
                loadDataToTable(vListStudent);
            }
        }
        }
        //load table 
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gUserTable.clear();
      //Cập nhật data cho bảng 
      gUserTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gUserTable.draw();
    }

     //function get Current info on click button Chi tiet
     function getCurrentInfo(paraBtn){
        var vTrCurrent = $(paraBtn).closest("tr");
        console.log(vTrCurrent);
        var vTable = $("#table-student").DataTable();
        var vCurrentInfo = vTable.row(vTrCurrent).data();
        return vCurrentInfo;
    }
</script>
</html>